<template>
    <modal @modal-close="close()">
        <div class="bg-white rounded-lg shadow-lg overflow-hidden" style="width: 700px;">
                <div class="p-8">
                    <heading :level="2" class="mb-6 text-90 font-normal text-xl">Pridanie klincov do cenníku</heading>
                    <div class="text-100 container">

                        <div class="flex bg-30 p-2 rounded-lg">


                            <div class="flex-1">
                                <label class="font-bold">
                                    Kategória
                                    <button @click.prevent="selectAllCategories()" class="rounded p-1 text-80 hover:text-20 hover:bg-70"><i class="far fa-check-square font-normal"></i></button>
                                    <span>/</span>
                                    <button @click.prevent="deselectAllCategories()" class="rounded p-1 text-80 hover:text-20 hover:bg-70"><i class="far fa-square font-normal"></i></button>
                                </label>
                                <div class="flex">
                                    <div
                                        v-for="category in nailCategories"
                                        :key="category.id"
                                        class="m-2"
                                    >
                                        <input
                                            type='checkbox'
                                            :value="category.id"
                                            v-model="selectedCategories"
                                            class="mr-2"
                                        >{{ category.name }}
                                    </div>
                                </div>

                            </div>

                            <div>
                                <label class="font-bold">Povrchová úprava</label>
                                <div class="flex">
                                    <div
                                        class="m-2"
                                    >
                                        <input
                                            type='checkbox'
                                            value="0"
                                            class="mr-2"
                                            v-model="selectedFinishes"
                                        > bez úpravy
                                    </div>
                                    <div
                                        v-for="finish in nailFinishies"
                                        :key="finish.id"
                                        class="m-2"
                                    >
                                        <input
                                            type='checkbox'
                                            :value="finish.id"
                                            class="mr-2"
                                            v-model="selectedFinishes"
                                        >{{ finish.name }}
                                    </div>

                                </div>

                            </div>

                        </div>

                        <div class="container p-2 bg-30 mt-2 rounded-t-lg">

                            <button @click.prevent="selectAllNails()" class="rounded p-1 text-80 hover:text-20 hover:bg-70"><i class="far fa-check-square text-xl font-normal"></i></button>
                            <span>/</span>
                            <button @click.prevent="deselectAllNails()" class="rounded p-1 text-80 hover:text-20 hover:bg-70"><i class="far fa-square text-xl font-normal"></i></button>
                        </div>

                        <div style="max-height: 400px;overflow-y: scroll;">
                            <div
                                v-for="(nail,index) in nailsFiltered"
                                :key="nail.id"
                                class="flex hover:bg-20 cursor-pointer"
                                @click="checkNail(nail.id)"
                            >
                                <div class="p-2"><input :value="nail.id" v-model="selectedNails" type="checkbox"></div>
                                <div class="flex-1 p-2">{{ nail.wire.average }} x {{ nail.length }}</div>
                                <div class="p-2">{{ nail.nail_category.name }}</div>
                            </div>
                        </div>

                    </div>
                </div>
                <div class="bg-30 px-6 py-3 flex">
                    <div class="flex items-center ml-auto">
                        <button
                                type="button"
                                class="btn text-80 font-normal h-9 px-3 mr-3 btn-link"
                                @click="close()"
                        >
                            Zrušiť
                        </button>

                        <button
                            type="button"
                            class="btn btn-default btn-danger"
                            @click="addNailsToPriceList()"
                        >
                            Pridať
                        </button>
                    </div>
                </div>

        </div>
    </modal>
</template>

<script>
    export default {
        props: {
            nailCategories: {
                type: Array,
                default: () => ([]),
            },
            nailFinishies: {
                type: Array,
                default: () => ([]),
            },
            priceListId: {
            }
        },
        data: () => ({
            selectedNails: [],
            selectedCategories: [0],
            selectedFinishes: [0],
            nails: [],
        }),
        computed: {
            nailsFiltered() {
                let tmpNails = []
                this.nails.forEach(nail => {

                    if (this.selectedCategories.includes(nail.nail_category_id) ) {
                        tmpNails.push(nail)
                    }
                })
                return tmpNails
            }
        },
        watch: {
            selectedCategories() {
                this.deselectNailsInNonActiveCategories()
            }
        },
        methods: {
            close (refresh) {
                this.$emit('close', refresh)
            },
            addNailsToPriceList() {

                let data = {};
                data.priceListId = this.priceListId
                data.selectedNails = this.selectedNails
                data.selectedFinishes = this.selectedFinishes

                Nova.request().post('/nova-vendor/price-list-items-form/add-nails-to-price-list', data)
                    .then(response => {
                        console.log(response)
                        this.close(true)
                    })

            },
            loadNails () {

                Nova.request().get('/nova-vendor/price-list-items-form/get-nails')
                    .then(response => {
                        this.nails = response.data
                        this.nails.map(item => {
                            item.checked = false
                            return item
                        })
                    })
            },
            checkNail (id) {

                let tmp = this.selectedNails
                if (tmp.includes(id)) {
                    _.pull(tmp, id)
                } else {
                    tmp.push(id)
                }

                this.selectedNails = tmp
                this.$forceUpdate();

            },
            selectAllNails() {
                this.selectedNails = []
                this.nails.forEach(nail => {
                    if (this.selectedCategories.includes(nail.nail_category_id)) {
                        this.selectedNails.push(nail.id)
                    }
                })
            },
            deselectAllNails() {
                this.selectedNails = []
            },
            deselectNailsInNonActiveCategories() {
                this.nails.forEach(nail => {
                    if (this.selectedNails.includes(nail.id) && !this.selectedCategories.includes(nail.nail_category_id)) {
                        _.pull(this.selectedNails, nail.id)
                    }
                })
            },
            selectAllCategories() {
                this.selectedCategories = []
                this.nailCategories.forEach(cat => {this.selectedCategories.push(cat.id)})
            },
            deselectAllCategories() {
                this.selectedCategories = []
                this.selectedNails = []
            }
        },
        mounted() {
            this.loadNails();
            this.selectAllCategories();
        },

    }
</script>

<style scoped>

</style>